@echo off
title Building the 'lib4neuro' project for Release

set BUILD_SOMETHING_LIB=yes
set BUILD_LIB=yes
set BUILD_TESTS=yes
set BUILD_EXAMPLES=yes

rem call VsDevCmd.bat

title Building the 'lib4neuro' project for Release [preparing makefiles]

rem C++ compiler (Requires Visual Studio 2015)
set CXX_COMPILER=cl
set C_COMPILER=cl

set MAKEFILE_GENERATOR="Visual Studio 14 2015 Win64"

cmake -G %MAKEFILE_GENERATOR% -DCMAKE_VERBOSE_MAKEFILE:BOOL=ON -DCMAKE_BUILD_TYPE=Release -DCMAKE_CXX_COMPILER=%CXX_COMPILER% -DCMAKE_C_COMPILER=%C_COMPILER% -DBOOST_ROOT=%BOOST_ROOT% -DBOOST_LIBRARYDIR=%BOOST_LIBRARYDIR% -DBOOST_INCLUDEDIR=%BOOST_INCLUDEDIR% -DBUILD_TESTS=%BUILD_TESTS% -DBUILD_EXAMPLES=%BUILD_EXAMPLES% -DBUILD_LIB=%BUILD_LIB% -DLIB4NEURO_DIR=build\lib -DDEPENDENCIES_LINK_TYPE=%LINK_TYPE% -DLIB4NEURO_INCLUDE_DIR=%LIB4NEURO_INCLUDE_DIR% -S . -B build

title Building the 'lib4neuro' project for Release [building]
    
call set_env_n_cores.bat 
    
if "%BUILD_SOMETHING_LIB%" == "yes" (    
	cmake --build build -j %N_CORES% --config Release && echo "Build complete."
)
