@echo off
title Building the 'lib4neuro' project for Debug

set BUILD_SOMETHING_LIB=yes
set BUILD_LIB=yes
set BUILD_TESTS=yes
set BUILD_EXAMPLES=yes

rem call VsDevCmd.bat

	title Building the 'lib4neuro' project for Debug [preparing makefiles]
	
	rem C++ compiler (Requires Visual Studio 2017)
	set CXX_COMPILER=cl
	set C_COMPILER=cl

	set MAKEFILE_GENERATOR="Visual Studio 15 2017 Win64"
    
	cmake -G "Visual Studio 15 2017 Win64" -DCMAKE_VERBOSE_MAKEFILE:BOOL=ON -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=%CXX_COMPILER% -DCMAKE_C_COMPILER=%C_COMPILER% -DBOOST_ROOT=%BOOST_ROOT% -DBOOST_LIBRARYDIR=%BOOST_LIBRARYDIR% -DBOOST_INCLUDEDIR=%BOOST_INCLUDEDIR% -DBUILD_TESTS=%BUILD_TESTS% -DBUILD_EXAMPLES=%BUILD_EXAMPLES% -DBUILD_LIB=%BUILD_LIB% -DLIB4NEURO_DIR=build\lib -DDEPENDENCIES_LINK_TYPE=%LINK_TYPE% -DLIB4NEURO_INCLUDE_DIR=%LIB4NEURO_INCLUDE_DIR% .
	title Building the 'lib4neuro' project for Debug [building]
    
    call set_env_n_cores.bat 
    
if "%BUILD_SOMETHING_LIB%" == "yes" (    
	cmake --build . -j %N_CORES% --config Debug && echo "Build complete."
)
