MESSAGE("DownloadLapacke starting...")

SET(LAPACKE_LOCAL_PATH ${ROOT_DIR}/external_dependencies/Lapacke)

INCLUDE(FetchContent)

####################
# Download Lapacke #
####################
SET(LAPACKE_FILES ${LAPACKE_LOCAL_PATH}/lapacke.h ${LAPACKE_LOCAL_PATH}/liblapacke.dll ${LAPACKE_LOCAL_PATH}/liblapacke.lib)

ADD_CUSTOM_COMMAND(
    OUTPUT ${LAPACKE_LOCAL_PATH}/lapacke.h
    COMMAND ${CMAKE_COMMAND} -DURL_FOR_DOWNLOAD=https://icl.cs.utk.edu/lapack-for-windows/include/lapacke.h -DFILE_TO_SAVE=${LAPACKE_LOCAL_PATH}/lapacke.h -P ${CMAKE_CURRENT_LIST_DIR}/DownloadFromUrl.cmake
    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
    VERBATIM
    COMMAND_EXPAND_LISTS
)

ADD_CUSTOM_COMMAND(
    OUTPUT ${LAPACKE_LOCAL_PATH}/liblapacke.dll
    COMMAND ${CMAKE_COMMAND} -DURL_FOR_DOWNLOAD=https://icl.cs.utk.edu/lapack-for-windows/libraries/VisualStudio/3.7.0/Dynamic-MINGW/Win64/liblapacke.dll -DFILE_TO_SAVE=${LAPACKE_LOCAL_PATH}/liblapacke.dll -P ${CMAKE_CURRENT_LIST_DIR}/DownloadFromUrl.cmake
    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
    VERBATIM
    COMMAND_EXPAND_LISTS
)

ADD_CUSTOM_COMMAND(
    OUTPUT ${LAPACKE_LOCAL_PATH}/liblapacke.lib
    COMMAND ${CMAKE_COMMAND} -DURL_FOR_DOWNLOAD=https://icl.cs.utk.edu/lapack-for-windows/libraries/VisualStudio/3.7.0/Dynamic-MINGW/Win64/liblapacke.lib -DFILE_TO_SAVE=${LAPACKE_LOCAL_PATH}/liblapacke.lib -P ${CMAKE_CURRENT_LIST_DIR}/DownloadFromUrl.cmake
    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
    VERBATIM
    COMMAND_EXPAND_LISTS
)

SET(ENV{LAPACKE_HEADERS} ${LAPACKE_LOCAL_PATH}/lapacke.h)
LIST(APPEND LAPACKE_LIBRARIES "${LAPACKE_LOCAL_PATH}/liblapacke.lib")
#"${LAPACKE_LOCAL_PATH}/liblapacke.dll"
SET(ENV{LAPACKE_LIBRARIES} ${LAPACKE_LIBRARIES})
OPTION(ENV{LAPACKE_LOCAL} ON)

ADD_CUSTOM_TARGET(lapacke_build DEPENDS ${LAPACKE_FILES})
