
#ifndef LIB4NEURO_NEURON_BINARYBIASED_SERIALIZATION_H
#define LIB4NEURO_NEURON_BINARYBIASED_SERIALIZATION_H

#include <boost/serialization/base_object.hpp>
#include <boost/archive/text_oarchive.hpp>
#include <boost/archive/text_iarchive.hpp>
#include <boost/serialization/export.hpp>

#include "NeuronSerialization.h"
#include "NeuronBinaryBiased.h"

BOOST_CLASS_EXPORT_KEY(lib4neuro::NeuronBinaryBiased);
 
namespace lib4neuro {
    struct NeuronBinaryBiased::access {
        template<class Archive>
        static void serialize(Archive& ar,
                              lib4neuro::NeuronBinaryBiased& n,
                              const unsigned int version) {
            ar & boost::serialization::base_object<Neuron>(n);
        }
    };
}

namespace boost {
    namespace serialization {

        /**
         * Serialization function
         * @tparam Archive Boost library template
         * @param ar Boost parameter - filled automatically during serialization!
         * @param n NeuronBinaryBiased instance
         * @param version Boost parameter - filled automatically during serialization!
         */
        template<class Archive>
        void serialize(Archive& ar,
                       lib4neuro::NeuronBinaryBiased& n,
                       const unsigned int version) {
            lib4neuro::NeuronBinaryBiased::access::serialize(ar,
                                                       n,
                                                       version);
        }

    } // namespace serialization
} // namespace boost


#endif //LIB4NEURO_NEURON_BINARYBIASED_SERIALIZATION_H
