
#ifndef LIB4NEURO_NEURONFILTERSERIALIZATION_H
#define LIB4NEURO_NEURONFILTERSERIALIZATION_H

#include <boost/serialization/base_object.hpp>
#include <boost/archive/text_oarchive.hpp>
#include <boost/archive/text_iarchive.hpp>
#include <boost/serialization/export.hpp>

#include "NeuronFilter.h"
#include "NeuronSerialization.h"

BOOST_CLASS_EXPORT_KEY(lib4neuro::NeuronFilter);

namespace lib4neuro {
    struct NeuronFilter::access {
        template<class Archive>
        static void serialize(Archive& ar,
                              NeuronFilter& n,
                              const unsigned int version) {
            ar & boost::serialization::base_object<Neuron>(n);
        }
    };
}

namespace boost {
    namespace serialization {

        /**
         * Serialization function
         * @tparam Archive Boost library template
         * @param ar Boost parameter - filled automatically during serialization!
         * @param n NeuronFilter instance
         * @param version Boost parameter - filled automatically during serialization!
         */
        template<class Archive>
        void serialize(Archive& ar,
                       lib4neuro::NeuronFilter& n,
                       const unsigned int version) {
            lib4neuro::NeuronFilter::access::serialize(ar,
                                                          n,
                                                          version);
        }

    } // namespace serialization
} // namespace boost

#endif //LIB4NEURO_NEURONFILTERSERIALIZATION_H
