
#ifndef LIB4NEURO_NEURONLINEARSATURATEDSERIALIZATION_H
#define LIB4NEURO_NEURONLINEARSATURATEDSERIALIZATION_H

#include <boost/serialization/base_object.hpp>
#include <boost/archive/text_oarchive.hpp>
#include <boost/archive/text_iarchive.hpp>
#include <boost/serialization/export.hpp>

#include "NeuronLinearSaturated.h"
#include "NeuronSerialization.h"

BOOST_CLASS_EXPORT_KEY(lib4neuro::NeuronLinearSaturated);

namespace lib4neuro {
    struct NeuronLinearSaturated::access {
        template<class Archive>
        static void serialize(Archive& ar,
                              NeuronLinearSaturated& n,
                              const unsigned int version) {
            ar & boost::serialization::base_object<Neuron>(n);
			ar & n.saturation_point;
        }
    };
}

namespace boost {
    namespace serialization {

        /**
         * Serialization function
         * @tparam Archive Boost library template
         * @param ar Boost parameter - filled automatically during serialization!
         * @param n NeuronLinearSaturated instance
         * @param version Boost parameter - filled automatically during serialization!
         */
        template<class Archive>
        void serialize(Archive& ar,
                       lib4neuro::NeuronLinearSaturated& n,
                       const unsigned int version) {
            lib4neuro::NeuronLinearSaturated::access::serialize(ar,
                                                          n,
                                                          version);
        }

    } // namespace serialization
} // namespace boost

#endif //LIB4NEURO_NEURONLINEARSATURATEDSERIALIZATION_H
