
#include <boost/serialization/export.hpp>

#include "NeuronRectifier.h"
#include "NeuronBinary.h"
#include "NeuronSerialization.h"
#include "NeuronRectifierSerialization.h"

BOOST_CLASS_EXPORT_IMPLEMENT(lib4neuro::NeuronRectifier);

namespace lib4neuro {
    NeuronRectifier::NeuronRectifier() {}

    double NeuronRectifier::activate(double x,
                                     double b) {
        this->activation_val = (0 < x + b) ? x + b : 0.0;
        return this->activation_val;
    }

    double NeuronRectifier::activation_function_eval_derivative_bias(double x,
                                                                		 double b) {
        // f'(0) = 0 for the purposes of training
        return ((x + b) > 0) ? 1.0 : 0.0;
    }

    double NeuronRectifier::activation_function_eval_derivative(double x,
                                                                double b) {
        // f'(0) = 0 for the purposes of training
        return ((x + b) > 0) ? 1.0 : 0.0;
    }

    Neuron* NeuronRectifier::get_derivative() {
        NeuronBinary* output = new NeuronBinary();
        return output;
    }


}