#include <iostream>

#include "4neuro.h"

int main() {

    l4n::CSVReader reader("x2_data.txt",
                          "\t",
                          true);
    reader.read();

    std::vector<unsigned int>     input_ind  = {0};
    std::vector<unsigned int>     output_ind = {1};
    std::shared_ptr<l4n::DataSet> ds         = reader.get_data_set(&input_ind,
                                                                   &output_ind);

    std::vector<unsigned int>     neuron_numbers_in_layers = {1, 15, 1};
    std::vector<l4n::NEURON_TYPE> hidden_type_v            = {l4n::NEURON_TYPE::LOGISTIC};
    l4n::FullyConnectedFFN        net(&neuron_numbers_in_layers,
                                      &hidden_type_v);

    l4n::MSE mse(&net,
                 ds.get());

    l4n::GradientDescent gs(1e-5,
                            20,
                            200000);

    net.randomize_parameters();
    gs.optimize(mse);

    mse.eval_on_data_set(ds.get());

    return 0;
}
