/**
 * DESCRIPTION OF THE CLASS
 *
 * @author David Vojtek
 * @date 2018
 */

#define BOOST_TEST_MODULE DataSet_test

// TODO fix boost_test_lib and remove the following include!
#ifdef _WINDOWS
#include <boost/test/included/unit_test.hpp>
#endif

#ifndef BOOST_TEST_DYN_LINK
#define BOOST_TEST_DYN_LINK
#endif

#ifndef BOOST_TEST_NO_MAIN
#define BOOST_TEST_NO_MAIN
#endif

#include <boost/test/unit_test.hpp>
#include <boost/test/output_test_stream.hpp>

#include "../DataSet/DataSet.h"
#include "stdio.h"
#include <iostream>

/**
 * Boost testing suite for testing DataSet.h
 */
BOOST_AUTO_TEST_SUITE(DataSet_test)


/**
 * Test of lib4neuro::DataSet constructor with filepath parameter
 */
    BOOST_AUTO_TEST_CASE(DataSet_construction_from_file_test) {
        //test of exception with non-existing file path
        //TODO resolve exception throw
        //lib4neuro::DataSet DataSet("file/unknown");

        //BOOST_CHECK_THROW(lib4neuro::DataSet DataSet("file unknown"), std::out_of_range);// boost::archive::archive_exception::input_stream_error);
    }

/**
 * Test of DataSet constructor with vector parameter
 */
    BOOST_AUTO_TEST_CASE(DataSet_construction_from_vector_test) {
        std::vector<std::pair<std::vector<double>, std::vector<double>>> data_vec;
        std::vector<double>                                              inp, out;

        for (int i = 0; i < 3; i++) {
            inp.push_back(i);
            out.push_back(i + 4);
        }

        data_vec.emplace_back(std::make_pair(inp,
                                             out));

        lib4neuro::DataSet ds(&data_vec); // TODO why is the ds object created unitialized?

        //test of no exception when create object DataSet
        BOOST_CHECK_NO_THROW(new lib4neuro::DataSet(&data_vec));
    }


BOOST_AUTO_TEST_SUITE_END()
